## gate.swing
Class XJTable.TableSorter

    java.lang.Object
      |
      +--javax.swing.table.AbstractTableModel
            |
            +--gate.swing.TableMap
                  |
                  +--gate.swing.XJTable.TableSorter

All Implemented Interfaces:
  EventListener, Serializable, TableModel, TableModelListener

Enclosing class:
  XJTable

class XJTable.TableSorter
extends TableMap

A sorter for TableModels. The sorter has a model (conforming to TableModel) and itself implements TableModel. TableSorter does not store or copy the data in the TableModel, instead it maintains an array of integers which it keeps the same size as the number of rows in its model. When the model changes it notifies the sorter that something has changed eg. "rowsAdded" so that its internal array of integers can be reallocated. As requests are made of the sorter (like getValueAt(row, col) it redirects them to its model via the mapping array. That way the TableSorter appears to hold another copy of the table with the rows in a different order. The sorting algorthm used is stable which means that it does not move around rows when its comparison function returns 0 to denote that they are equivalent.

See Also:
  Serialized Form

Field Summary
`(package private) int[]` `indexes`
`(package private) Vector` `sortingColumns`

Fields inherited from class gate.swing.TableMap
`model`

Fields inherited from class javax.swing.table.AbstractTableModel
`listenerList`

Constructor Summary
`XJTable.TableSorter()`
`XJTable.TableSorter(TableModel model)`

Method Summary
`void` `checkModel()`
`int` `compare(int row1, int row2)`
`int` `compareRowsByColumn(int row1, int row2, int column)`
`Object` `getValueAt(int aRow, int aColumn)`
`boolean` `isCellEditable(int aRow, int aColumn)`
`void` `reallocateIndexes()`
`void` `setModel(TableModel model)`
`void` `setValueAt(Object aValue, int aRow, int aColumn)`
`void` `shuttlesort(int[] from, int[] to, int low, int high)`
`void` `sort(Object sender)`
`void` `sortByColumn(int column)`
`void` `swap(int i, int j)`
`void` `tableChanged(TableModelEvent e)`

Methods inherited from class gate.swing.TableMap
`getColumnClass, getColumnCount, getColumnName, getModel, getRowCount`

Methods inherited from class javax.swing.table.AbstractTableModel
`addTableModelListener, findColumn, fireTableCellUpdated, fireTableChanged, fireTableDataChanged, fireTableRowsDeleted, fireTableRowsInserted, fireTableRowsUpdated, fireTableStructureChanged, getListeners, removeTableModelListener`

Methods inherited from class java.lang.Object
`<clinit>, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### indexes

    int[] indexes

### sortingColumns

    Vector sortingColumns

Constructor Detail

### XJTable.TableSorter

    public XJTable.TableSorter()

### XJTable.TableSorter

    public XJTable.TableSorter(TableModel model)

Method Detail

### setModel

    public void setModel(TableModel model)

  Overrides:
    `setModel` in class `TableMap`

### compareRowsByColumn

    public int compareRowsByColumn(int row1,
                                   int row2,
                                   int column)

### compare

    public int compare(int row1,
                       int row2)

### reallocateIndexes

    public void reallocateIndexes()

### tableChanged

    public void tableChanged(TableModelEvent e)

  Overrides:
    `tableChanged` in class `TableMap`

### checkModel

    public void checkModel()

### sort

    public void sort(Object sender)

### shuttlesort

    public void shuttlesort(int[] from,
                            int[] to,
                            int low,
                            int high)

### swap

    public void swap(int i,
                     int j)

### getValueAt

    public Object getValueAt(int aRow,
                             int aColumn)

  Overrides:
    `getValueAt` in class `TableMap`

### setValueAt

    public void setValueAt(Object aValue,
                           int aRow,
                           int aColumn)

  Overrides:
    `setValueAt` in class `TableMap`

### isCellEditable

    public boolean isCellEditable(int aRow,
                                  int aColumn)

  Overrides:
    `isCellEditable` in class `TableMap`

### sortByColumn

    public void sortByColumn(int column)